Core - Bug # 46446

Status: Needs Feedback Priority: Must have

Author: Philipp Idler Category: File Abstraction Layer (FAL)
Created: 2013-03-20 Assigned To:

Updated: 2015-07-17 Due date:

TYPO3 Version: 6.0

PHP Version:

Complexity:

Is Regression: No

Sprint Focus: Remote Sprint

Subject: sys_file doesn't get updated

Description

Replacing an image with different dimensions but same filename gets rendered in frontend with old dimensions of previous image.

Reproduce:

Add textpic element on a page, upload an image and save. View it frontend. Everything fine so long...
Now edit this element, delete the image and upload another image with different dimensions but same filename.

TYPO3 renders the new image in frontend with the dimensions in IMG-tag of previous image.

Related issues:

related to Core - Bug # 46482: cached image sizes (sys_file) are not updated ... New 2013-03-21
related to Core - Bug # 61181: FAL: file maxW and maxH are ignored Rejected 2014-08-25
related to Core - Bug # 50392: Specifying size in ImageViewHelper does nothing Closed 2013-07-24
related to Core - Bug # 59216: Image dimensions (width/height) are 0 when not... Closed 2014-05-30
related to Core - Bug # 62400: Lot of entries in sys_file_processed with name... Rejected 2014-10-22
duplicated by Core - Bug # 44105: Image size does not get updated Closed 2012-12-19
History

#1 - 2013-03-22 10:38 - Andreas Wolf

- Status changed from New to Accepted

This is due to the fact that the old processed file records are not thrown away. Anyways, the processed files should be regenerated when the image
has been changed (because of new timestamp and hash), so something is clearly broken here.

#2 - 2013-03-26 11:46 - Andreas Kiessling

Just had a similar effect: i had to rename a folder "externally" and my fluid template had the new path to the image file, but it generated the old path
(only changed one letter to lowercase). | found two entries in sys_file and after deleting both it worked again.

#3 - 2013-05-14 23:06 - Alexander Opitz

@Andreas This haven't to do with this issue, that was the upper-/lowercase filesystem/sql like statements problem, we already spoke about.

#4 - 2013-09-12 12:27 - Camelia M
Philipp Idler wrote:

Replacing an image with different dimensions but same filename gets rendered in frontend with old dimensions of previous image.

Reproduce:

Add textpic element on a page, upload an image and save. View it frontend. Everything fine so long...
Now edit this element, delete the image and upload another image with different dimensions but same filename.

TYPQO3 renders the new image in frontend with the dimensions in IMG-tag of previous image.

this problem still exists (at least in typo3 6.1.3).

#5 - 2013-09-20 08:47 - Thomas Etter

Problem is also existant in Typo3 6.1.5

#6 - 2014-01-14 15:12 - Alexander Opitz

- Project changed from File Abstraction Layer to Core

- Category changed from Frontend to Frontend

#7 - 2014-01-14 15:13 - Alexander Opitz

- Category changed from Frontend to File Abstraction Layer (FAL)
- Is Regression set to No

- TYPOS3 Version set to 6.0

#8 - 2014-04-02 20:33 - Markus Klein

Is this still an issue on 6.2?

#9 - 2014-05-10 14:17 - Sebastian Fischer

Replacing an image with same name but different resolution resulted in a different image size in the frontend in current master. But the thumbnail still

displays the old image content.

#10 - 2014-11-20 12:23 - Andreas Allacher

| just noticed this issue again too with 6.2.6 (as | mentioned in a related bug but that one was closed).

I guess it will not be an issue for files in fileadmin but files that are distributed via extesion public resources can still be a problem.

e.g. | just updated an image inside my extension but the sys_file record still used the old image size and therefore the image was rendered wrongly
(not even ratio was correct) and in this case the image was not even resized but just rendered directly.

| was using the ImageViewHelper for the output.

| can avoid this by using uri.resource and the tag directly but that way | am losing resize functionality etc.

Maybe checking the if the original file timestamp matches the current timestamp and if not check the SHA1 value before rendering?
#11 - 2015-01-06 11:44 - Frans Saris

All processed files should be deleted when a file is replaced. Should be done on signal
\TYPO3\CMS\Core\Resource\ResourceStorage::postFileReplace like TYPO3\CMS\Core\Resource\Processing\FileDeletionAspect

#12 - 2015-01-06 13:40 - Mathias Schreiber
- Target version set to 7.1 (Cleanup)
- Sprint Focus set to On Location Sprint

#13 - 2015-05-29 08:49 - Michael Sollmann

When | replace an image (shown with CType "uploads” and sys_file_collection) "data = file:current:tstamp" shows the tstamp of the old image even if |
clear the cache. Same problem?

#14 - 2015-06-15 17:44 - Benjamin Mack
- Target version changed from 7.1 (Cleanup) to 7.4 (Backend)

#15 - 2015-06-17 17:17 - Pierrick Caillon
- Status changed from Accepted to In Progress
- Assigned To set to Pierrick Caillon

#16 - 2015-06-17 17:54 - Pierrick Caillon
- Status changed from In Progress to Needs Feedback
- Assigned To deleted (Pierrick Caillon)

Using master initialized with bootstrap package, | cannot reproduce the issue.

1. | created a test page. | created a testpic. Set some title and description. Selected image alignment as "In text, left" to have the image processed.
Then used "Select & upload files" to upload my first test image with name 46446_test.jpg. The image is a landscape photograph. And finally saved.

2. The image displays correctly in frontend. The image thumbnail in backend is as expected.

3. | edited again the content. Removed the image using its "Delete record (!)" button. Used again the "Select & upload files" button to upload my
second test image which | have put in a different folder to name it the same. The image is a portrait photograph. And finally saved.

4. The image displays correctly in frontend. The image thumbnail in backend was as expected before and after saving.

Regarding comment 10 (#46446-10), it is linked to issue #64196.

#17 - 2015-07-17 13:48 - Susanne Moog

- Sprint Focus changed from On Location Sprint to Remote Sprint

Files

img-dimensions.jpg 52.9 kB 2013-03-20 Philipp Idler
